/*
 * Next Framework http://www.nextframework.org
 * Copyright (C) 2009 the original author or authors.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * 
 * You may obtain a copy of the license at
 * 
 *     http://www.gnu.org/copyleft/lesser.html
 * 
 */
package org.nextframework.authorization.impl;


import java.util.Map;
import java.util.Set;

import org.nextframework.authorization.AuthorizationDAO;
import org.nextframework.authorization.Permission;
import org.nextframework.authorization.Role;
import org.nextframework.authorization.User;

/**
 * Implementao padro para aplicaes que no utilizam autorizao.
 * Essa implementao suporta os modulos de autorizao padro do NEXT. 
 * Ele d permisso para qualquer tela para qualquer usurio.
 * No deve ser extendida, usada pelo framework caso no seja 
 * fornecida nenhuma classe de autorizao.
 * @author rogelgarcia
 * @since 22/01/2006
 * @version 1.1
 */
public final class AuthorizationDAOImpl implements AuthorizationDAO {

	public User findUserByLogin(final String login) {
		return new User(){

			public String getLogin() {
				return login;
			}

			public String getPassword() {
				return null;
			}};
	}

	public Role[] findUserRoles(User user) {
		return new Role[0];
	}

	public Permission findPermission(Role role, String controlName) {
		return null;
	}

	public Permission savePermission(final String controlName, final Role role, final Map<String, String> permissionMap) {
		return new Permission(){

			@SuppressWarnings("unused")
			public String getControlname() {
				return controlName;
			}

			public Role getRole() {
				return role;
			}

			public Map<String, String> getPermissionmap() {
				Set<String> keySet = permissionMap.keySet();
				for (String string : keySet) {
					permissionMap.put(string, "true");
				}
				return permissionMap;
			}

			public String getPermissionvalue(String id) {
				return "true";
			}};
	}

	public Role[] findAllRoles() {
		return new Role[0];
	}

}
