/*
 * Next Framework http://www.nextframework.org
 * Copyright (C) 2009 the original author or authors.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * 
 * You may obtain a copy of the license at
 * 
 *     http://www.gnu.org/copyleft/lesser.html
 * 
 */
package org.nextframework.core.config;

import java.util.List;
import java.util.Properties;

import org.nextframework.authorization.AuthorizationManager;
import org.nextframework.authorization.PermissionLocator;
import org.nextframework.bean.AnnotatedBeanRegister;
import org.nextframework.bean.BeanDescriptorFactory;
import org.nextframework.bean.TypeBeanRegister;
import org.nextframework.controller.ControlMappingLocator;
import org.nextframework.report.ReportGenerator;
import org.nextframework.rtf.RTFGenerator;
import org.springframework.beans.factory.support.DefaultListableBeanFactory;

/**
 * @author rogelgarcia
 * @since 21/01/2006
 * @version 1.1
 */
public interface Config {

	AnnotatedBeanRegister[] getBeanRegisters();
	TypeBeanRegister[] getTypeBeanRegisters();
	Properties getProperties();
	ReportGenerator getReportGenerator();
	RTFGenerator getRTFGenerator();
	AuthorizationManager getAuthorizationManager();
	//UserLocator getUserLocator();
	PermissionLocator getPermissionLocator();
	ControlMappingLocator getControlMappingLocator();
	//AuthorizationDAO getAuthorizationDAO();
	BeanDescriptorFactory getBeanDescriptorFactory();
	//mtodo utilizado para inicializar a configuracao
	ValidatorRegistry getValidatorRegistry();
	
	int getMaxUploadSize();
	
	DefaultListableBeanFactory getDefaultListableBeanFactory();
	void setDefaultListableBeanFactory(DefaultListableBeanFactory defaultListableBeanFactory);
	void init();
	boolean isPersistTemporaryFiles();
	
}
