/*
 * Next Framework http://www.nextframework.org
 * Copyright (C) 2009 the original author or authors.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * 
 * You may obtain a copy of the license at
 * 
 *     http://www.gnu.org/copyleft/lesser.html
 * 
 */
package org.nextframework.core.web.init;

import java.util.List;

import javax.servlet.ServletContextEvent;

import org.springframework.web.context.ContextLoader;

/**
 * Listener substituto do spring.<BR>
 * Configurar no web.xml
 * @author rogelgarcia
 * @since 21/01/2006
 * @version 1.1
 */
public class ContextLoaderListener extends org.springframework.web.context.ContextLoaderListener {
	
	@Override
	public void contextInitialized(ServletContextEvent event) {
		try {
			super.contextInitialized(event);
		} catch (Exception e) {
			//pegaremos a exceo para a aplicao inicializar corretamente, ela j estar logada e o stack trace impresso
			//se ocorrer algum problema durante a inicializacao o NextFilter informar
		}
	}

	@Override
	protected ContextLoader createContextLoader() {
		return new org.nextframework.core.web.init.ContextLoader();
	}
}
