package org.nextframework.persistence;

/**
 * Listener utilizado em conjunto com o SaveOrUpdateStrategy para verificar excluso de itens.
 * @author rogelgarcia
 *
 */
public interface CollectionItemDeleteListener<E> {

	/**
	 * Invocado para cada objeto que ser excluido.<BR>
	 * 
	 *  responsabilidade da implementao chamar o mtodo execute do parametro chain para efetuar a excluso do objeto.
	 * @param chain
	 */
	public void onDelete(E object, SaveOrUpdateStrategyChain chain);
}
