package org.nextframework.persistence;

import org.nextframework.util.Util;

class DAODelegateSaveOrUpdateStrategyListener<E> implements SaveOrUpdateStrategyListener<E> {

	DAO<E> collectionDAO;

	@SuppressWarnings("unchecked")
	public void onSaveOrUpdate(E object, SaveOrUpdateStrategyChain chain) {
		if(collectionDAO == null){
			collectionDAO = (DAO<E>) Util.beanFacotries.getDAOForClass(object.getClass());
		}
		collectionDAO.saveOrUpdate(object);
	}

	@SuppressWarnings("unchecked")
	public void onDelete(E object, SaveOrUpdateStrategyChain chain) {
		if(collectionDAO == null){
			collectionDAO = (DAO<E>) Util.beanFacotries.getDAOForClass(object.getClass());
		}
		collectionDAO.delete(object);
	}
}
