/*
 * Next Framework http://www.nextframework.org
 * Copyright (C) 2009 the original author or authors.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * 
 * You may obtain a copy of the license at
 * 
 *     http://www.gnu.org/copyleft/lesser.html
 * 
 */
package org.nextframework.report;

import java.util.Map;

/**
 * Interface que define um relatrio
 * @author rogelgarcia
 * @since 22/01/2006
 * @version 1.1
 */
public interface IReport {
	
	/**
	 * 
	 * @return nome do arquivo do relatrio
	 */
	String getFileName();
	
	/**
	 * 
	 * @return nome do relatrio
	 */
	String getName();
	
	/**
	 * @return mapa de parametros do relatrio
	 */
	Map<String, Object> getParameters();

	/**
	 * Fonte de dados do Relatrio
	 * Pode ser um array (beans ou map) ou Collection (beans ou map).
	 * @return objeto com os dados do relatrio
	 */
	Object getDataSource();
	
	/**
	 * 
	 * @return mapa de subrelatrios
	 */
	Map<String, IReport> getSubReportMap();
}
