/*
 * Next Framework http://www.nextframework.org
 * Copyright (C) 2009 the original author or authors.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * 
 * You may obtain a copy of the license at
 * 
 *     http://www.gnu.org/copyleft/lesser.html
 * 
 */
package org.nextframework.util;

import java.awt.Image;
import java.io.IOException;
import java.io.InputStream;

import javax.imageio.ImageIO;
import javax.servlet.ServletContext;

import org.nextframework.core.standard.Next;
import org.nextframework.core.web.NextWeb;
import org.nextframework.core.web.WebApplicationContext;

public class NextImageResolver implements ImageResolver{

	public static NextImageResolver getInstance() {
		return Next.getObject(NextImageResolver.class);
	}

	public Image getImage(String path) throws IOException {
		ServletContext context = ((WebApplicationContext) NextWeb.getApplicationContext()).getServletContext();
		InputStream stream = context.getResourceAsStream(path);
		return ImageIO.read(stream);
	}

}
